/* -
 * (C) NTT TechnoCross Corporation 2019 All Rights Reserved
 */

#include <stdio.h>
#include <rte_ethdev.h>  /**<パケット処理API */
#include <rte_mbuf.h>    /**<パケットバッファAPI */

#include "fwd.h"

/**
 *  パケット転送処理(メインループ)
 *  - 指定のportから受信したパケットを同じportに転送する
 */
void fwd_main_loop(uint16_t port_id) {
  struct rte_mbuf *pkts[32];    /* パケット取得用の領域 */
  uint16_t nb_rx, nb_tx, i = 0; /* パケット受信/送信数 */
  printf("\nForwards packets received on port %u to port %u.\n", port_id,
         port_id);
  /**
   *  - パケットを受信したら、受信したパケットを同じportに転送
   *  - もしパケット送信に失敗したら送信しようとしたパケットを破棄
   */
  while (1) {
    nb_rx = rte_eth_rx_burst(port_id, 0, pkts, 32);
    if (nb_rx <= 0)
      continue;
    nb_tx = rte_eth_tx_burst(port_id, 0, pkts, nb_rx);
    if (nb_tx < nb_rx)
      for (i = nb_tx; i < nb_rx; i++)
        rte_pktmbuf_free(pkts[i]);
  }
}
